# -*- coding: utf-8 -*-
"""
/***************************************************************************
 mnt_cen38
                                 A QGIS plugin
 mnt_cen38
 Generated by Plugin Builder: http://g-sherman.github.io/Qgis-Plugin-Builder/
                              -------------------
        begin                : 2022-08-31
        git sha              : $Format:%H$
        copyright            : (C) 2022 by colas Geier / CEN 38
        email                : colas.geier@cen-isere.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
"""
import importlib
from qgis.PyQt.QtCore import QSettings, QTranslator, QCoreApplication
from qgis.PyQt.QtGui import QIcon,QPixmap
from qgis.PyQt.QtWidgets import QAction,QMessageBox
from qgis.core import QgsGeometry, QgsVectorLayer, QgsRasterLayer, QgsProcessingUtils, QgsDataSourceUri, QgsZipUtils,QgsMapLayerProxyModel
from qgis import processing
from os import listdir,remove, chdir, path, stat, mkdir, getcwd
import sys
import subprocess
# from pathlib import Path
import shutil

import importlib
checklib = importlib.util.find_spec('osgeo_utils')
notfoundlib = checklib is None

if sys.platform == 'win32' and notfoundlib:
    sys.path.append('C:\\OSGeo4~1\\bin')
    import gdal_merge as gm
else:
    from osgeo_utils import gdal_merge as gm

# Initialize Qt resources from file resources.py
from .resources import *
# Import the code for the dialog
from .mnt_cen38_dialog import mnt_cen38Dialog
# import os.path
# from webdav3.client import Client

def _run_cmd(cmd,encod='latin-1'):
    if sys.version_info.minor >= 7 :
        res = subprocess.run(cmd,text=True,shell=True,capture_output=True,encoding=encod)
    else : 
        res = subprocess.run(cmd,text=True,shell=True,stdout=subprocess.PIPE,stderr=subprocess.PIPE,encoding=encod)
    return res

def _runcmd(cmd, verbose = False, *args, **kwargs):

    process = subprocess.Popen(
        cmd,
        stdout = subprocess.PIPE,
        stderr = subprocess.PIPE,
        text = True,
        shell = True
    )
    std_out, std_err = process.communicate()
    if verbose:
        return std_out.strip(), std_err
    pass

def _create_randomfolder(random_path):
    import string
    import random
    p = ''.join(random.SystemRandom().choice(string.ascii_uppercase + string.digits) for _ in range(30))
    mkdir(path.join(random_path,p))
    return p

class mnt_cen38:
    """QGIS Plugin Implementation."""

    def __init__(self, iface):
        """Constructor.

        :param iface: An interface instance that will be passed to this class
            which provides the hook by which you can manipulate the QGIS
            application at run time.
        :type iface: QgsInterface
        """
        # Save reference to the QGIS interface
        self.path_orig = getcwd()
        self.path_alti = '/CEN_38/Altimétrie/'
        self.domain = 'drive.craig.fr'
        self.domain_pub = 'drive.opendata.craig.fr'
        self.url_craig = "https://%s/remote.php/webdav/"%self.domain
        self.urlpub_craig = "https://%s/s/opendata/download?path=/lidar/lidar_hd_ign/38_Isere/"%self.domain_pub
        self.wdavpub_craig = "https://%s/public.php/webdav/"%self.domain_pub
        self.usrpub = 'opendata'
        self.usr = None
        self.pwd = None

        self.iface = iface
        # initialize plugin directory
        self.plugin_dir = path.dirname(__file__)
        # initialize locale
        locale = QSettings().value('locale/userLocale')[0:2]
        locale_path = path.join(
            self.plugin_dir,
            'i18n',
            'mnt_cen38_{}.qm'.format(locale))

        if path.exists(locale_path):
            self.translator = QTranslator()
            self.translator.load(locale_path)
            QCoreApplication.installTranslator(self.translator)

        # Declare instance attributes
        self.actions = []
        self.menu = self.tr(u'&mnt_cen38')

        # Check if plugin was started the first time in current QGIS session
        # Must be set in initGui() to survive plugin reloads
        self.first_start = None

    # noinspection PyMethodMayBeStatic
    def tr(self, message):
        """Get the translation for a string using Qt translation API.

        We implement this ourselves since we do not inherit QObject.

        :param message: String for translation.
        :type message: str, QString

        :returns: Translated version of message.
        :rtype: QString
        """
        # noinspection PyTypeChecker,PyArgumentList,PyCallByClass
        return QCoreApplication.translate('mnt_cen38', message)


    def add_action(
        self,
        icon_path,
        text,
        callback,
        enabled_flag=True,
        add_to_menu=True,
        add_to_toolbar=True,
        status_tip=None,
        whats_this=None,
        parent=None):
        """Add a toolbar icon to the toolbar.

        :param icon_path: Path to the icon for this action. Can be a resource
            path (e.g. ':/plugins/foo/bar.png') or a normal file system path.
        :type icon_path: str

        :param text: Text that should be shown in menu items for this action.
        :type text: str

        :param callback: Function to be called when the action is triggered.
        :type callback: function

        :param enabled_flag: A flag indicating if the action should be enabled
            by default. Defaults to True.
        :type enabled_flag: bool

        :param add_to_menu: Flag indicating whether the action should also
            be added to the menu. Defaults to True.
        :type add_to_menu: bool

        :param add_to_toolbar: Flag indicating whether the action should also
            be added to the toolbar. Defaults to True.
        :type add_to_toolbar: bool

        :param status_tip: Optional text to show in a popup when mouse pointer
            hovers over the action.
        :type status_tip: str

        :param parent: Parent widget for the new action. Defaults None.
        :type parent: QWidget

        :param whats_this: Optional text to show in the status bar when the
            mouse pointer hovers over the action.

        :returns: The action that was created. Note that the action is also
            added to self.actions list.
        :rtype: QAction
        """

        icon = QIcon(icon_path)
        action = QAction(icon, text, parent)
        action.triggered.connect(callback)
        action.setEnabled(enabled_flag)

        if status_tip is not None:
            action.setStatusTip(status_tip)

        if whats_this is not None:
            action.setWhatsThis(whats_this)

        if add_to_toolbar:
            # Adds plugin icon to Plugins toolbar
            self.iface.addToolBarIcon(action)

        if add_to_menu:
            self.iface.addPluginToMenu(
                self.menu,
                action)

        self.actions.append(action)

        return action

    def initGui(self):
        """Create the menu entries and toolbar icons inside the QGIS GUI."""

        icon_path = ':/plugins/mnt_cen38/icon.png'
        self.add_action(
            icon_path,
            text=self.tr(u''),
            callback=self.run,
            parent=self.iface.mainWindow())

        # will be set False in run()
        self.first_start = True


    def unload(self):
        """Removes the plugin menu item and icon from QGIS GUI."""
        for action in self.actions:
            self.iface.removePluginMenu(
                self.tr(u'&mnt_cen38'),
                action)
            self.iface.removeToolBarIcon(action)


    def run(self):
        """Run method that performs all the real work"""
        # user = 'colas.geier'
        # pwd = 'CenAvenir38*'
        # options = {
        # 'webdav_hostname': "https://drive.craig.fr/remote.php/webdav/",
        # 'webdav_login':    user,
        # 'webdav_password': pwd
        # }
        # self.client = Client(options)
        # Create the dialog with elements (after translation) and keep reference
        # Only create GUI ONCE in callback, so that it will only load when the plugin is started
        if self.first_start == True:
            self.first_start = False
            self.dlg = mnt_cen38Dialog()
            # self.dlg.image_2.setPixmap(QPixmap(':/img/CEN38-LOGO-320x128.png'))
            self.dlg.listeLayerMap.setFilters(QgsMapLayerProxyModel.VectorLayer)
            self.dlg.to_CRAIG.clicked.connect(self.init_CRAIG)
            self.dlg.buttonRun.clicked.connect(self.accept)
            self.dlg.return_dialog.setOpenExternalLinks(True)
            self.dlg.return_dialog.setAcceptRichText(True)

        self.path_craigpub = self.init_CRAIG_PUB()
        
        if self.dlg.listeMNT.currentText() == '' or not self._craig_ismount():
            self.init_CRAIG()

        # self.buttonBox.rejected.connect(self.reject)
        # show the dialog
        self.dlg.show()

        # Run the dialog event loop
        result = self.dlg.exec_()

        # See if OK was pressed
        if result:
            pass


    def accept(self):
        self.dlg.buttonRun.setChecked(False)
        self.get_MNT()
        # pass


    def callback_craig(self,diag):
        self.dlg.return_dialog.setPlainText(diag)


    def get_param_connect(self):
        if self.dlg.mAuthConfigSelect.configId():
            authCfg = self.dlg.mAuthConfigSelect.configId()
            quri = QgsDataSourceUri()
            quri.setParam("authcfg", authCfg)
            quri.setParam("url", self.url_craig)
            self.usr = quri.uri().split("user='")[1].split("' ",1)[0]
            self.pwd = quri.uri().split("password='")[1].split("' ",1)[0]
            return True
        else :
            return False


    def init_CRAIG(self):
        if self.dlg.to_CRAIG.isChecked:
            self.dlg.to_CRAIG.setChecked(False)
        is_connect = self.get_param_connect()

        mount = []
        # if is_connect:
        mount = self._init_CRAIG()

        self.lstdir_alti = []
        self.lst_altipub = []

        if self.mount_craigpub:
            self.path_tolidar = path.join(self.path_craigpub,'lidar','lidar_hd_ign','38_Isere')
            self.lst_altipub += [x for x in listdir(
                self.path_tolidar
            ) if 'MNT' in x]
            self.lstdir_alti += self.lst_altipub
        if mount:
            chdir(mount)
            self.mount = mount
            self.lstdir_alti += listdir(self.path_alti[1:])
            chdir(self.path_orig)
        
        self.set_listMNT(self.lstdir_alti)


    def _craig_ismount(self):
        if sys.platform == 'win32':
            cmd1 = 'net use'
            out1 = _run_cmd(cmd1,encod='latin-1')
            while 'Non disponib' in out1.stdout:
                m = out1.stdout.split('Non disponib ')[1][:2]
                _run_cmd('net use %s /delete'%m)
                out1 = _run_cmd(cmd1,encod='latin-1')
            stdout = out1.stdout
            lstm = [x for x in stdout.split('\n') if ': ' in x]
            listletter_mount = [x.split(':')[0][-1] for x in lstm]
            craig_ismount = [x for x in stdout.split('\n') if (self.domain in x)&('Non disponib' not in x)]
        elif sys.platform == 'linux':
            cmd1 = 'mount -v | grep "%s\|drive.craig"'%self.domain
            # out1 = subprocess.run(cmd1,shell=True,capture_output=True,encoding='utf-8')
            out1 = _run_cmd(cmd1,encod='utf-8')
            craig_ismount = []
            if out1.stdout:
                craig_ismount.append(out1.stdout.split('on ')[1].split(' type fuse')[0])
        return craig_ismount


    def init_CRAIG_PUB(self):
        self.mount_craigpub = False
        if sys.platform == 'win32':
            cmd1 = 'net use'
            # out1 = subprocess.run(cmd1,shell=True,capture_output=True,encoding='latin-1')
            out1 = _run_cmd(cmd1,encod='latin-1')
            while 'Non disponib' in out1.stdout:
                m = out1.stdout.split('Non disponib ')[1][:2]
                _run_cmd('net use %s /delete'%m)
                out1 = _run_cmd(cmd1,encod='latin-1')
            stdout = out1.stdout
            lstm = [x for x in stdout.split('\n') if ': ' in x]
            listletter_mount = [x.split(':')[0][-1] for x in lstm]
            craig_ismount = [x for x in stdout.split('\n') if (self.domain_pub in x)&('Non disponib' not in x)]
            if not craig_ismount:
                # letter_mount = self.mount_craigWin()
                cmd2 = 'net use * {url} /USER:{usr}'.format(
                    url = self.wdavpub_craig,
                    usr = self.usrpub
                )
                out2 = _run_cmd(cmd2,encod='latin-1')
                if out2.stderr:
                    self.callback_craig(diag=out2.stderr)
                else:
                    return out2.stdout.split(':')[0][-1]
            else : 
                letter_mount = [x.split(':')[0][-1] for x in craig_ismount]
            
            mount = letter_mount[0]+'://' if letter_mount else None

            self.mount_craigpub = True
            return mount
        elif sys.platform == 'linux':
            cmd1 = 'mount -v | grep "%s\|opendata.craig"'%self.domain_pub
            out1 = _run_cmd(cmd1,encod='utf-8')
            if out1.stdout:
                mount = out1.stdout.split('on ')[1].split(' type fuse')[0]
                self.mount_craigpub = True
                return mount
            else:
                self.callback_craig(diag="Il n'existe pas de point de montage pour l'adresse suivante :\n%s"%self.domain_pub)



    def _init_CRAIG(self):
        if sys.platform == 'win32':
            cmd1 = 'net use'
            # out1 = subprocess.run(cmd1,shell=True,capture_output=True,encoding='latin-1')
            out1 = _run_cmd(cmd1,encod='latin-1')
            while 'Non disponib' in out1.stdout:
                m = out1.stdout.split('Non disponib ')[1][:2]
                _run_cmd('net use %s /delete'%m)
                out1 = _run_cmd(cmd1,encod='latin-1')
            stdout = out1.stdout
            lstm = [x for x in stdout.split('\n') if ': ' in x]
            listletter_mount = [x.split(':')[0][-1] for x in lstm]
            craig_ismount = [x for x in stdout.split('\n') if (self.domain in x)&('Non disponib' not in x)]
            if not craig_ismount:
                letter_mount = self.mount_craigWin()
            else : 
                letter_mount = [x.split(':')[0][-1] for x in craig_ismount]
            
            mount = letter_mount[0]+'://' if letter_mount else None
            return mount
        elif sys.platform == 'linux':
            cmd1 = 'mount -v | grep "%s\|drive.craig"'%self.domain
            out1 = _run_cmd(cmd1,encod='utf-8')
            if out1.stdout:
                mount = out1.stdout.split('on ')[1].split(' type fuse')[0]
                return mount
            else:
                self.callback_craig(diag="Il n'existe pas de point de montage pour l'adresse suivante :\n%s"%self.domain)



    def mount_craigWin(self):
        if self.pwd and self.usr:
            cmd2 = 'net use * {url} {pwd} /USER:{usr}'.format(
                url = self.url_craig,
                pwd = self.pwd,
                usr = self.usr
            )
            out2 = _run_cmd(cmd2,encod='latin-1')
            if out2.stderr:
                self.callback_craig(diag=out2.stderr)
            else:
                return out2.stdout.split(':')[0][-1]
        else:
            self.callback_craig(diag="Vous n'êtes pas connecté au CRAIG et aucun identifiant est sélectionné.\nVeuillez creer un point de montage ou sélectionner vos identifiants du CRAIG.")


    def set_listMNT(self,listMNT):
        self.dlg.listeMNT.clear()
        if listMNT:
            self.dlg.listeMNT.setEnabled(True)
            self.dlg.listeMNT.addItems(listMNT)
            self.dlg.return_dialog.setPlainText('Vous êtes connecté au CRAIG !')
        else:
            self.dlg.listeMNT.setEnabled(False)
            self.dlg.return_dialog.clear()
            self.dlg.return_dialog.setPlainText("No ident selected ! Veuillez sélectionner vos identifiants du CRAIG.\n\nEn l'absence d'identifiant, réalisez votre demande à l'adresse suivante :")
            self.dlg.return_dialog.append("\n <a href=https://ids.craig.fr/console/account/new>CRAIG</a>")


    def progress_bar(self,value):
        v = self.dlg.progressBar.value()
        self.dlg.progressBar.setValue(v+value)

    def _check_usespace2_linux(self,listefile):

        total, used, free = shutil.disk_usage("/")
        # Estimate size of dowloading
        estim_size = 0
        f = ''
        while estim_size < free and f != listefile[-1]:
            for f in listefile:
                cmd_size = 'wget --spider "https://drive.opendata.craig.fr/s/opendata/download?path=/lidar/lidar_hd_ign/38_Isere/{typ_mnt}&files={file}"'.format(typ_mnt='03_MNT_50cm',file=f)
                out = _run_cmd(cmd_size)

                if out.stderr:
                    s = out.stderr.split('Taille')[-1].strip().split(' ')[1]
                    estim_size += int(s)
                else: 
                    raise("File %s non atteint à l'adresse indiquée"%f) 
        
        if estim_size > free : 
            self.callback_craig(diag='Espace disponible insufisant : %sGo'%round(free/1000000000,2))
            return False
        else :
            return True

        


    def _check_usespace(self,listefile):
        # Estimate size of dowloading
        estim = sum(stat(d).st_size for d in listefile)    # stat() in bytes ; /1000000 ==> Mo ; /1000000000 ==> Go
        total, used, free = shutil.disk_usage("/")
        if estim > free :
            self.callback_craig(diag="La création du MNT nécessite %sGo.\nEspace disponible : %sGo"%(
                round(estim/1000000000,2),
                round(free/1000000000,2)
            ))
            chdir(self.path_orig)
            return False
        elif estim > free*0.9 : 
            res = self.showdialog(estim,free)
            return res
            # self.callback_craig(diag="La création du MNT nécessite %sGo.\nEspace disponible : %sGo\nVoullez-vous vraiment continuer ?"%(
            #     round(estim/1000000000,2),
            #     round(free/1000000000,2)
            # ))
        else :
            return True


    def showdialog(estim,free):
        msg = QMessageBox()
        msg.setIcon(QMessageBox.Information)

        msg.setText("L'espace disponible sur votre machine va atteindre sa limite")
        msg.setInformativeText("La création du MNT nécessite %sGo.\nEspace disponible : %sGo\nVoullez-vous vraiment continuer ?"%(
                round(estim/1000000000,2),
                round(free/1000000000,2)
            ))
        msg.setWindowTitle("Attention : faible espace disponible")
        msg.setDetailedText("The details are as follows:")
        msg.setStandardButtons(QMessageBox.Ok | QMessageBox.Cancel)
            
        retval = msg.exec_()
        return True if retval else False


    def get_MNT(self):

        self.dlg.progressBar.setValue(self.dlg.progressBar.minimum())
        # Union layer select
        emprise = False
        layer = self.dlg.listeLayerMap.currentLayer()
        if emprise :
            bbox = layer.extent()
            union = QgsGeometry.fromRect(bbox)
        else :
            geoms = [f.geometry() for f in layer.getFeatures()]
            union = QgsGeometry.unaryUnion(geoms)
            # layer =  QgsVectorLayer('Polygon', 'poly' , "memory")
        self.progress_bar(5)

        # Locate & import dalle
        mnt = self.dlg.listeMNT.currentText()

        # Si MNT from CRAIG_PUBLIC
        if mnt in self.lst_altipub:
            chdir(
                path.join(self.path_tolidar,'01_TA')
            )
            dallage = [i for i in listdir() if (i.endswith(r'.gpkg')) and ('MNT' in i)][0]
        # AUTREMENT
        else :
            path_dalle = self.path_alti+mnt+'/'
            chdir(self.mount)
            chdir('.'+path_dalle)
            dallage = [i for i in listdir() if (i.endswith(r'.gpkg')) and (i.startswith('_dallage'))][0]
        
        
        # Copie du dallage
        tmp_fold = QgsProcessingUtils.tempFolder()+'/'
        tmp_file = tmp_fold+dallage

        if mnt in self.lst_altipub:
            cmd_linux_dal = 'wget "{urlpub}{typ_mnt}&files={file_in}" -O {file_out}'.format(urlpub=self.urlpub_craig,typ_mnt='01_TA',file_in=dallage,file_out=path.join(tmp_fold,dallage))
            cmd_win_dal = """
            $WebClient = New-Object system.net.webclient
            $WebClient.DownloadData('{urlpub}{typ_mnt}&files={file_in}',{OUT})
            """.format(urlpub=self.urlpub_craig,typ_mnt='01_TA',file_in=dallage,OUT=path.join(tmp_fold,dallage))
            print(dallage)
            print(cmd_linux_dal)
            print(cmd_win_dal)
            
            out_d = _run_cmd(cmd_win_dal) if sys.platform == 'win32' else  _run_cmd(cmd_linux_dal)
            print(out_d)
        else :
            shutil.copy(dallage,tmp_fold)

        # Load dalle
        chdir(self.path_orig)
        vlayer = QgsVectorLayer(tmp_file, dallage, "ogr")

        # Ident intersects dalles vs layer
        if mnt in self.lst_altipub:
            # chdir(path.join(self.path_tolidar,mnt))
            lst_dalles = [
                d['name']+d['format']
                for d in vlayer.getFeatures() if union.intersects(d.geometry())
            ]
        else :
            lst_dalles = [d['location'] for d in vlayer.getFeatures() if union.intersects(d.geometry())]


        lst_d = [file.split(r'/')[-1] if '/' in file else file for file in lst_dalles]
        lst_d = list(set(lst_d))
        self.callback_craig(diag="Intersection de %i dalles ...\nEstimation de l'espace requis ..."%len(lst_d))

        self.progress_bar(5)
        if mnt in self.lst_altipub:
            # if sys.platform == 'win32':
            usespacefree = self._check_usespace(listefile=lst_d) if sys.platform == 'win32' else self._check_usespace2_linux(listefile=lst_d)
        else:
            chdir(self.mount)
            chdir('.'+path_dalle)
            usespacefree = self._check_usespace(listefile=lst_dalles)

        # Close dalle
        del vlayer

        self.progress_bar(5)
        if not usespacefree:
            pass
        elif not lst_dalles:
            self.callback_craig(diag="Aucune dalle **%s** a été identifiée intersectant la géométrie sélectionnée"%mnt)
            self.dlg.progressBar.setValue(self.dlg.progressBar.minimum())
            chdir(self.path_orig)
        else:
            # x = (self.dlg.progressBar.maximum()/2)-self.dlg.progressBar.value()
            p = 5
            x = (self.dlg.progressBar.maximum()-self.dlg.progressBar.value())/3*2
            l = len(lst_dalles)
            pas = round(l/(x/p))
            PAS = [pas*i for i in range(1,int((x/p)))] + [l]

            self.callback_craig(diag="**Initiation du téléchargement des %i plaques**"%l)
            for i,file in enumerate(lst_dalles):
                if mnt in self.lst_altipub:
                    cmd_copy = 'wget "{urlpub}{typ_mnt}&files={file_in}" -O {file_out}'.format(urlpub=self.urlpub_craig,typ_mnt=mnt,file_in=file,file_out=path.join(tmp_fold,file))
                    _runcmd(cmd_copy)
                    # _run_cmd("mv '"+cmd_copy.split('/opendata/')[1].replace('/','%2F').removesuffix('"')+"' "+file)
                else:
                    f = file.split(r'/')[-1] if '/' in file else file
                    shutil.copy(file,tmp_fold)

                self.progress_bar(p) if i in PAS else None
            self.callback_craig(diag="Fin du téléchargement ...\nCréation du raster avec gdal_merge ..."%l)

            lst_tmpd = []
            x = self.dlg.progressBar.maximum()-self.dlg.progressBar.value()-10
            d = _create_randomfolder(tmp_fold)
            OUTPUT = path.join(tmp_fold,d,'output_mnt.tif')
            lstmnt = [path.join('/vsizip/'+tmp_fold,z,z[:-4]+'_MNT_LAMB93_IGN69.asc') if z[-3:]=='zip' else path.join(tmp_fold,z) for z in lst_d]
            parameters = ['', '-o', OUTPUT,'-of','GTIFF','-n','-99999','-a_nodata','0'] + lstmnt
            # self.callback_craig(diag="**%s**"%parameters)
            print(parameters)
            gm.main(parameters)
            self.progress_bar(int(x))
            # for d in lst_d:
            #     if d.split('.')[-1] == 'zip':
            #         tmp = QgsZipUtils.unzip(tmp_fold+d,tmp_fold)
            #         if tmp[0] is True:
            #             lst_tmp = [x for x in tmp[1] if 'MNT' in x]
            #             if lst_tmp: lst_tmpd.append(lst_tmp[0])
            #     else :
            #         lst_tmpd.append(d)
            #     self.progress_bar(int(round(1*x/l,1)))
            
            # os.chdir(tmp_fold)
            # param = {
            #     "INPUT": lst_tmpd,
            #     "NODATA_INPUT": -99999,
            #     "NODATA_OUTPUT": 0,
            #     "OUTPUT": 'TEMPORARY_OUTPUT'
            # }
            # merge = processing.run('gdal:merge', param)


            for l in lst_d:
                remove(tmp_fold+l) if path.exists(tmp_fold+l) else None

            for ltd in [x for x in lst_tmpd if x not in lst_d]:
                remove(ltd) if tmp_fold in ltd else remove(tmp_fold+ltd)

            files = listdir(tmp_fold)
            lst_tif = [x for x in files if (x.endswith('.tif')) and (x.startswith(lst_tmpd[0].split(r'/')[-1][:10]))]
            # lst_dal = [x for x in files if x.startswith(dallage)]
            # for ld in lst_dal:
            #     remove(tmp_fold+ld)
            for lt in lst_tif:
                remove(tmp_fold+lt)

            x = self.dlg.progressBar.maximum()-self.dlg.progressBar.value()
            self.progress_bar(x)
            chdir(self.path_orig)
            self.iface.addRasterLayer(OUTPUT, "output_layer")

